/*
 * Project ReD
 * request.java -- main request handling thread class
 * Copyright (C) Filip Pizlo 1997
 * This code is under GPL 2.0
 * You must read the README before proceeding!
 */

import java.io.*;
import java.net.*;
import java.util.*;

class request extends jdth {
 Socket sock;
 InputStream in;
 OutputStream out;
 PrintStream fout;
 DataInputStream fin;
 boolean hdrsent,head,full,frld;
 String dir,frlog,src,env[];
 int envc;
 request(centrale _blow,Socket _sock,int _tid) {
  super();
  blow=_blow;
  tid=_tid;
  sock=_sock;
  hdrsent=false;
  dir=""+blow.mdir;
  frlog="";
  frld=false;
  src="";
  env=new String[50];
  envc=0;
  setenv("SERVER_NAME",blow.hostnm);
  setenv("SERVER_PORT",""+blow.port);
  setenv("SERVER_SOFTWARE",centrale.VERSION);
  setenv("GATEWAY_INTERFACE",centrale.CGIVER);
  try {
   out=sock.getOutputStream();
   in=sock.getInputStream();
   fout=new PrintStream(out);
   fin=new DataInputStream(in);
  } catch (Exception e) {
   doh(e,true);
   return;
  }
  start();
 }
 public void run() {
  try {
   logit("Connection recieved!");
   logdate();
   frlog=frlog+"["+(new Date())+"] ";
   src=sock.getInetAddress().getHostAddress();
   setenv("REMOTE_ADDR",src);
   logit("Connection source: "+src);
   String reqline=fin.readLine();
   if (reqline==null) crapout("Disconnect");
   StringTokenizer tox=new StringTokenizer(reqline);
   String cmd,pr1,pr2;
   full=false;
   head=true;
   if (tox.countTokens()<2) senderror(400);
   cmd=tox.nextToken();
   setenv("REQUEST_METHOD",cmd);
   logit("Request command: "+cmd);
   pr1=tox.nextToken();
   frlog=frlog+"\""+cmd+"\" "+pr1+" -> "+src+" (";
   setenv("SCRIPT_NAME",pr1);
   frld=true;
   pr2="HTTP/0.0";
   if (tox.hasMoreTokens()) pr2=tox.nextToken();
   setenv("SERVER_PROTOCOL",pr2);
   boolean post=false;
   int pstln=-1;
   String psttp="application/url-encoded";
   if (cmd.equals("GET")) full=true;
   else if (cmd.equals("HEAD")) full=false;
   else if (cmd.equals("POST")) {
    full=true;
    post=true;
   } else senderror(400);
   int major=-1,minor=-1;
   try {
    major=Integer.parseInt(pr2.substring(pr2.indexOf('/')+1,pr2.indexOf('.')));
    minor=Integer.parseInt(pr2.substring(pr2.indexOf('.')+1,pr2.length()));
   } catch (Exception e2) {}
   if (major>=1&&minor>=0) {
    head=true;
    while (true) {
     String buf=fin.readLine();
     int coli=buf.indexOf(':');
     if (coli<0) break;
     String hnm=buf.substring(0,coli),hvl=buf.substring(coli+2,buf.length());
     if (hnm.equals("From")) logit("Email: "+hvl);
     else if (hnm.equals("User-Agent")) {
      logit("Client: "+hvl);
      setenv("HTTP_USER_AGENT",hvl);
     } else if (hnm.equals("Content-length")) {
      logit("Content Length: "+hvl);
      pstln=Integer.parseInt(hvl);
      setenv("CONTENT_LENGTH",hvl);
     } else if (hnm.equals("If-Modified-Since")) {
      logit("If-Modified-Since: "+hvl);
      setenv("IF_MODIFIED_SINCE",hvl);
     } else if (hnm.equals("Pragma")) {
      logit("Pragma: "+hvl);
      setenv("HTTP_PRAGMA",hvl);
     } else if (hnm.equals("Content-type")) {
      logit("Content Type: "+hvl);
      psttp=""+hvl;
      setenv("CONTENT_TYPE",hvl);
     } else if (hnm.equals("Referer")) {
      logit("Refered from: "+hvl);
      setenv("HTTP_REFERER",hvl);
      setenv("REFERER_URL",hvl);
     } else if (hnm.equals("Host")) {
      logit("Accessed on: "+hvl);
      coli=hvl.indexOf(':');
      if (coli<0) coli=hvl.length();
      String tmp=hvl.substring(0,coli);
      int virtc=blow.whatvirt(tmp);
      if (virtc>=0) dir=""+blow.vdirs[virtc];
     } else if (hnm.equals("Accept")) {
      logit("Accepts: "+hvl);
      setenv("HTTP_ACCEPT",hvl);
     }
    }
   } else head=false;
   if (!full&&!head) senderror(400);
   String flnm=""+pr1,uext="",user="0";
   logit("Requested "+flnm);
   int mimec,userc,tilde;
   boolean cgi=false;
   tilde=flnm.indexOf('?');
   if (tilde>=0) {
    uext=flnm.substring(tilde+1,flnm.length());
    logit("URL Extension: "+uext);
    setenv("QUERY_STRING",uext);
    flnm=flnm.substring(0,tilde);
   }
   if (blow.cgidr&&flnm.startsWith(blow.fcgidr)) {
    flnm=flnm.substring(9,flnm.length());
    dir=blow.rcgidr;
    cgi=true;
   }
   tilde=flnm.indexOf('~');
   if (tilde==0||(tilde==1&&flnm.charAt(0)=='/')) {
    flnm=flnm.substring(tilde+1,flnm.length());
    int sep=flnm.indexOf('/');
    if (sep<0) {
     userc=blow.whatuser(flnm);
     flnm="/";
    } else {
     userc=blow.whatuser(flnm.substring(0,sep));
     flnm=flnm.substring(sep+1,flnm.length());
    }
    if (userc<0) senderror(404);
    user=blow.usrs[userc];
    dir=blow.udirs[userc];
   }
   if (flnm.indexOf("..")>=0) senderror(400);
   flnm=flnm.replace('/',File.separatorChar);
   flnm=dir+flnm;
   if (flnm.endsWith(""+File.separatorChar)) {
    File tfl;
    int i;
    for (i=0;i<blow.rfln;i++) {
     tfl=new File(flnm+blow.rfl[i]);
     if (tfl.exists()) break;
    }
    if (i<blow.rfln) flnm=flnm+blow.rfl[i];
    else senderror(404);
   }
   logit("Converted to "+flnm);
   mimec=blow.whatmime(flnm);
   if (mimec==2&&blow.cgiex) cgi=true;
   if (post&&!cgi) senderror(400);
   if (cgi) logit("Its a CGI!");
   int code=200;
   File fl=new File(flnm);
   if (!fl.exists()) senderror(404);
   boolean dtsent=false;
   try {
    if (cgi) {
     logit("Sending the output of the CGI");
     Runtime run=Runtime.getRuntime();
     setenv("PWD",(new File(flnm)).getParent());
     String nenv[]=new String[envc];
     for (int i=0;i<envc;i++) nenv[i]=""+env[i];
     String cmds[]=new String[2];
     cmds[0]=flnm;
     cmds[1]=uext;
     Process proc=run.exec(cmds,nenv);
     header(200,mimec,-1,true);
     InputStream cin=proc.getInputStream();
     OutputStream cout=proc.getOutputStream();
     DataInputStream fcin=new DataInputStream(cin);
     if (post) {
      blow.tcnt++;
      new pipe(fin,cout,pstln,blow,blow.tcnt);
     }
     while (true) {
      String buf=fcin.readLine();
      if (buf==null||buf.indexOf(":")<0) break;
      if (head) fout.println(buf);
     }
     if (head) fout.println("");
     dtsent=true;
     while (true) {
      int b=cin.read();
      if (b<0) break;
      if (full) out.write(b);
     }
     cin.close();
     proc.destroy();
    } else {
     logit("Sending the contents of the doc");
     FileInputStream flin=new FileInputStream(fl);
     header(200,mimec,flin.available(),false);
     if (full) {
      byte rdbuf[]=new byte[65536];
      dtsent=true;
      while (true) {
       int res=flin.read(rdbuf,0,65536);
       if (res<0) break;
       fout.write(rdbuf,0,res);
      }
     }
     flin.close();
    }
   } catch (Exception e) {
    if (!dtsent) senderror(500);
    else crapout("Error in sending");
   }
   sock.close();
   fout.close();
   fin.close();
   frlog=frlog+code+")";
   blow.reqlog.print(frlog+lsep);
   frld=false;
   complete("Sent.");
  } catch (Exception e) {
   doh(e,true);
  }
 }
 void senderror(int code) {
  try {
   logit("Sending error");
   switch (code) {
    case 400:
     header(400,1,-1,false);
     fout.println("<html><head><title>Error: 400</title></head><body>");
     fout.println(blow.er400);
     fout.println("</body></html>");
     break;
    case 404:
     header(404,1,-1,false);
     fout.println("<html><head><title>Error: 404</title></head><body>");
     fout.println(blow.er404);
     fout.println("</body></html>");
     break;
    case 500:
     header(500,1,-1,false);
     fout.println("<html><head><title>Error: 500</title></head><body>");
     fout.println(blow.er500);
     fout.println("</body></html>");
     break;
    default:
     logit("Unknown code: "+code);
     senderror(500);
     break;
   }
   if (frld) {
    frlog=frlog+code+")";
    blow.reqlog.print(frlog+lsep);
    frld=false;
   }
   complete("Error sent");
  } catch (Exception e) {
   logit("Error "+e);
   if (code!=500) senderror(500);
   else crapout("Error in error 500");
  }
 }
 void header(int code,int mimec,int ln,boolean cgi) {
  if (hdrsent||!head) return;
  logit("Code: "+code);
  fout.println("HTTP/1.0 "+code+(code==200?" OK":" Error"));
  fout.println("Server: "+blow.VERSION);
  if (!cgi) {
   fout.println("Content-type: "+blow.mimes[mimec]);
   if (ln>=0) fout.println("Content-length: "+ln);
   fout.println("");
  }
  hdrsent=true;
 }
 public void goodstop() {
  try {
   sock.close();
  } catch (Exception e) {}
  stop();
 }
 void setenv(String r,String l) {
  boolean temp=false;
  int i;
  for (i=0;i<envc;i++) if (env[i].startsWith(r)) {
   temp=true;
   break;
  }
  env[i]=r+"="+l;
  if (!temp) envc++;
 }
}

